;;;; http-client-conditions.scm  -*- Scheme -*-
;;;; Kon Lovett, Jul '18
;;;; Kon Lovett, Jun '13

(module http-client-conditions

(;export
  ;
  http-condition? ;conflict w/ intarweb-conditions
  ;
  client-error-condition?
  client-error-response
  client-error-body
  ;
  server-error-condition?
  server-error-response
  server-error-body
  ;
  unexpected-server-response-condition?
  unexpected-server-response-response
  unexpected-server-response-body
  ;
  redirect-depth-exceeded-condition?
  redirect-depth-exceeded-uri
  ;
  formdata-error-condition?
  ;
  unsupported-uri-scheme-condition?
  unsupported-uri-scheme-uri-scheme
  unsupported-uri-scheme-request-uri
  ;
  unknown-authtype-condition?
  unknown-authtype-authtype)

(import scheme
  condition-utils)

;;

;from intraweb
(define http-condition?
  (make-condition-predicate exn http))

;;

(define client-error-condition?
  (make-condition-predicate exn http client-error))

(define client-error-response
  (make-condition-property-accessor client-error response))

(define client-error-body
  (make-condition-property-accessor client-error body))

;;

(define server-error-condition?
  (make-condition-predicate exn http server-error))

(define server-error-response
  (make-condition-property-accessor server-error response))

(define server-error-body
  (make-condition-property-accessor server-error body))

;;

(define unexpected-server-response-condition?
  (make-condition-predicate exn http unexpected-server-response))

(define unexpected-server-response-response
  (make-condition-property-accessor unexpected-server-response response))

(define unexpected-server-response-body
  (make-condition-property-accessor unexpected-server-response body))

;;

(define redirect-depth-exceeded-condition?
  (make-condition-predicate exn http redirect-depth-exceeded))

(define redirect-depth-exceeded-uri
  (make-condition-property-accessor server-error uri))

;;

(define formdata-error-condition?
  (make-condition-predicate exn http formdata-error))

;;

(define unsupported-uri-scheme-condition?
  (make-condition-predicate exn http unsupported-uri-scheme))

(define unsupported-uri-scheme-uri-scheme
  (make-condition-property-accessor server-error uri-scheme))

(define unsupported-uri-scheme-request-uri
  (make-condition-property-accessor server-error request-uri))

;;

(define unknown-authtype-condition?
  (make-condition-predicate exn http unknown-authtype))

(define unknown-authtype-authtype
  (make-condition-property-accessor server-error authtype))

) ;http-client-conditions
